package cn.ninegame.genericframework.basic;

/**
 * <p>Title: ucweb</p>
 * <p/>
 * <p>Description: </p>
 * 框架加解密管理类
 * <p>Copyright: Copyright (c) 2016</p>
 * <p/>
 * <p>Company: ucweb.com</p>
 *
 * @author ZhuZhiFan (zhifan.zzf@alibaba-inc.com)
 * @date 2016/3/1
 */
public class SecurityManager implements ISecurityDelegate{

    private ISecurityDelegate mSecurityDelegate;

    public ISecurityDelegate getSecurity(){
        return mSecurityDelegate;
    }
    
    public void setSecurity(ISecurityDelegate iSecurityDelegate){
        mSecurityDelegate = iSecurityDelegate;
    }

    @Override
    public String staticEncryptString(String data) {
        if (mSecurityDelegate != null){
            return mSecurityDelegate.staticEncryptString(data);
        } else {
            return data;
        }
    }

    @Override
    public String staticDecryptString(String data) {
        if (mSecurityDelegate != null){
            return mSecurityDelegate.staticDecryptString(data);
        } else {
            return data;
        }
    }

    @Override
    public String dynamicEncryptString(String data) {
        if (mSecurityDelegate != null){
            return mSecurityDelegate.dynamicEncryptString(data);
        } else {
            return data;
        }
    }

    @Override
    public String dynamicDecryptString(String data) {
        if (mSecurityDelegate != null){
            return mSecurityDelegate.dynamicDecryptString(data);
        } else {
            return data;
        }
    }

    @Override
    public byte[] dynamicEncryptByte(byte[] data) {
        if (mSecurityDelegate != null){
            return mSecurityDelegate.dynamicEncryptByte(data);
        } else {
            return data;
        }
    }

    @Override
    public byte[] dynamicDecryptByte(byte[] data) {
        if (mSecurityDelegate != null){
            return mSecurityDelegate.dynamicDecryptByte(data);
        } else {
            return data;
        }
    }

    @Override
    public boolean checkStaticFileValid(String path) {
        return mSecurityDelegate == null || mSecurityDelegate.checkStaticFileValid(path);
    }

    @Override
    public boolean initDynamicFileSignature(String path) {
        return mSecurityDelegate != null && mSecurityDelegate.initDynamicFileSignature(path);
    }

    @Override
    public boolean isDynamicFileValid(String path) {
        return mSecurityDelegate == null || mSecurityDelegate.isDynamicFileValid(path);
    }

    @Override
    public boolean putDynamicString(String key, String value) {
        return mSecurityDelegate != null && mSecurityDelegate.putDynamicString(key, value);
    }

    @Override
    public String getDynamicString(String key) {
        if (mSecurityDelegate != null) {
            return mSecurityDelegate.getDynamicString(key);
        } else {
            return null;
        }
    }

    @Override
    public boolean isRoot() {
        if (mSecurityDelegate != null) {
            return mSecurityDelegate.isRoot();
        } else {
            throw new RuntimeException("SecurityManager#isRootedSecurity(), Delegate should not be null");
        }
    }
}
